﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.CodeDom.Compiler;
using System.Reflection;
using System.Xml.Linq;
using Microsoft.CSharp;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.Helpers;
using Styx.WoWInternals;
using Bots.GatherBuddy;
using b = Bots.Gatherbuddy.Profile;


namespace gbshuffle
{
    public class gbshuffle : Styx.Plugins.HBPlugin
    {

        private ArrayList SubSections = new ArrayList();


        private bool startedLoop = false;
        private bool movedOn = false;
        private WoWPoint currentTarget;

        private Random rng;

        public gbshuffle()
        {
            //

            rng = new Random();
            BotEvents.OnBotStart += BotEventsOnOnBotStart;
            BotEvents.Profile.OnNewProfileLoaded += Profile_OnNewProfileLoaded;


            Logging.Write("hello!");

    


        }

        private void BotEventsOnOnBotStart(EventArgs args)
        {
           if (BotManager.Current.Name.Contains("Gather"))
           {
               SetSubsection();
           }
        }

        public override bool WantButton
        {
            get { return true; }
        }

        public override string ButtonText
        {
            get { return "gooby"; }
        }

        public override void OnButtonPress()
        {
        }


        void SetSubsection()
        {

            try
            {
                b.CurrentProfile.Path.Clear();

                var section = rng.Next(0, SubSections.Count);

                foreach (var x in (List<WoWPoint>)SubSections[section])
                {
                    Logging.Write(x.ToString());
                    b.CurrentProfile.Path.Add(x);
                }
                currentTarget = ((List<WoWPoint>)SubSections[section])[0];
                startedLoop = false;

            }
            catch (Exception e)
            {
                Logging.WriteDiagnostic(e.ToString());
            }

        }


        void Profile_OnNewProfileLoaded(BotEvents.Profile.NewProfileLoadedEventArgs args)
        {


            var z = args.NewProfile.XmlElement;
            var Sections = z.Nodes().Select(r => r as XElement).FirstOrDefault(r => r.Name == "Section");
            var XmlSubSections = Sections.Nodes().Select(r => r as XElement);
            foreach (var x in XmlSubSections)
            {
                List<WoWPoint> t = new List<WoWPoint>();
                foreach (var children in x.Nodes().Select(r => r as XElement))
                {
                    Dictionary<string, float> attributes = children.Attributes().ToDictionary(k => k.Name.ToString(),v => float.Parse(v.Value));
                    // use legacy X,Y,Z location
                    if (attributes.ContainsKey("X"))
                    {
                        //string location = string.Format("{0},{1},{2}", attributes["X"], attributes["Y"], attributes["Z"]);
                        t.Add(new WoWPoint(attributes["X"], attributes["Y"], attributes["Z"]));
                    }
                }
                SubSections.Add(t);
            }
            Logging.Write("Subsections populated");
        }

        public override void Pulse()
        {
            var next = b.CurrentProfile.Path.FirstOrDefault();

            if (next == currentTarget)
            {

                if (startedLoop)
                {
                    Logging.Write("Picking new subsection");
                    //Pick a new subsection to work
                    SetSubsection();
                }
                

            }
            else
            {
                startedLoop = true;
            }


        }

        public override string Name
        {
            get { return "gbshuffle"; }
        }

        public override string Author
        {
            get { return "Mastahg"; }
        }

        public override Version Version
        {
            get { return new Version(0, 0, 0, 1); }
        }
    }
}